#!/usr/bin/env batchflow
<?xml version="1.0"?>
<Document>
  <Network type="subnet" name="MAIN">
    <Node name="node_Constant_1" type="Constant" x="60" y="70">
      <Parameter name="VALUE" type="subnet_param" value="ARG1" description="The value"/>
    </Node>
    <Node name="node_InputStream_1" type="InputStream" x="260" y="70">
      <Parameter name="TYPE" type="String" value="" description="Type of stream: stream, fd, or FILE (default stream)"/>
      <Parameter name="RETRY" type="int" value="" description="If set to N, InputStream will retry N times on open fail"/>
    </Node>
    <Node name="node_MAIN_LOOP_1" type="MAIN_LOOP" x="480" y="70">
      <Parameter name="LENGTH" type="int" value="512" description="The frame length of each channel (in samples) [default: 512]."/>
      <Parameter name="ADVANCE" type="int" value="160" description="The shift length beween adjacent frames (in samples)[default: 160]."/>
    </Node>
    <Link from="node_Constant_1" output="VALUE" to="node_InputStream_1" input="INPUT"/>
    <Link from="node_InputStream_1" output="OUTPUT" to="node_MAIN_LOOP_1" input="INPUT"/>
    <NetOutput name="OUTPUT_AUDIO_SIGNAL" node="node_MAIN_LOOP_1" terminal="OUTPUT_AUDIO_SIGNAL" object_type="any" description="Dynamic"/>
  </Network>
  <Network type="iterator" name="MAIN_LOOP">
    <Node name="node_AudioStreamFromWave_1" type="AudioStreamFromWave" x="100" y="100">
      <Parameter name="LENGTH" type="subnet_param" value="LENGTH" description="The frame length of each channel (in samples) [default: 512]."/>
      <Parameter name="ADVANCE" type="subnet_param" value="ADVANCE" description="The shift length beween adjacent frames (in samples)[default: 160]."/>
      <Parameter name="USE_WAIT" type="bool" value="true" description="If true, real recording is simulated [default: false]."/>
    </Node>
    <Node name="node_MultiGain_1" type="MultiGain" x="650" y="100">
      <Parameter name="GAIN" type="float" value="0.0009765625" description="Gain factor."/>
    </Node>
    <Node name="node_ChannelSelector_1" type="ChannelSelector" x="400" y="100">
      <Parameter name="SELECTOR" type="object" value="&lt;Vector&lt;int&gt; 2 6&gt;" description="Channel selection setting which is a vector consisting of channel IDs (ID starts with 0). When the first three channels are selected from four channels, this should be set to &amp;lt;Vector&amp;lt;int&amp;gt; 0 1 2&amp;gt;."/>
    </Node>
    <Node name="node_WaveVisualization_1" type="WaveVisualization" x="100" y="210">
      <Parameter name="WINDOW_NAME" type="string" value="Visualization of signal wave" description="Window name of the time-azimuth map [default: Visualization of multisource directions]."/>
      <Parameter name="VISUALIZATION_TIME_LENGTH" type="float" value="10" description="Visualization window length to show at the same time [default: 10.0 seconds]."/>
      <Parameter name="ADVANCE" type="int" value="160" description="The length in sample between a frame and a previous frame [default: 160]."/>
      <Parameter name="SAMPLING_RATE" type="int" value="16000" description="Sampling rate (Hz) [default: 16000]."/>
    </Node>
    <Link from="node_AudioStreamFromWave_1" output="AUDIO" to="node_ChannelSelector_1" input="INPUT"/>
    <Link from="node_ChannelSelector_1" output="OUTPUT" to="node_MultiGain_1" input="INPUT"/>
    <Link from="node_MultiGain_1" output="OUTPUT" to="node_WaveVisualization_1" input="INPUT_AUDIO_SIGNAL"/>
    <NetInput name="INPUT" node="node_AudioStreamFromWave_1" terminal="INPUT" object_type="Stream" description="An audio input stream (IStream)."/>
    <NetCondition name="CONDITION" node="node_AudioStreamFromWave_1" terminal="NOT_EOF"/>
    <NetOutput name="OUTPUT_AUDIO_SIGNAL" node="node_WaveVisualization_1" terminal="OUTPUT_AUDIO_SIGNAL" object_type="any" description="Same as input"/>
  </Network>
</Document>
